/**
 * Created by GoLand.
 * User: xzghua@gmail.com
 * Date: 2019/12/2
 * Time: 18:39
 */
package main

import "fmt"

func main()  {

	a := [][]int{
		{0,0,1},
		{0,0,0},
		{0,0,0},
	}
	fmt.Println(uniquePathsWithObstacles(a))
}


func uniquePathsWithObstacles(obstacleGrid [][]int) int {
	n := len(obstacleGrid)
	m := len(obstacleGrid[0])

	dp := make([][]int,n)

	for i:=0;i<n;i++ {
		dps := make([]int,m)
		for j:=0;j<m;j++ {
			if obstacleGrid[i][j] == 1 {
				dps[j] = 0
				dp[i] = dps
				continue
			}

			if j == 0 && i == 0 {
				dps[0] = 1
				dp[i] = dps
				continue
			}

			if i == 0 {
				dps[j] = dp[i][j-1]
				dp[i] = dps
				continue
			}

			if j == 0 {
				dps[j] = dp[i-1][j]
				dp[i] = dps
				continue
			}

			dps[j] = dp[i-1][j] + dp[i][j-1]
			dp[i] = dps
		}
	}
	return dp[n-1][m-1]
}